<?php
class Abdj_Pager {

	function Abdj_Pager() {
		/*COMMENT_FUNCTION*/ //print '<b> | Class:</b>'.__CLASS__.'<b> | function:</b>'.__FUNCTION__.'<b> | Line:</b>'.__LINE__.'<b> | Debug: </b> Para() <br>';
		// initialize Class
		$this->SetPagerUri('abdj_cpage');
	} // function Pager()



	function SetPagerUri($pager_uri='abdj_cpage') {
		/*COMMENT_FUNCTION*/ //print '<b> | Class:</b>'.__CLASS__.'<b> | function:</b>'.__FUNCTION__.'<b> | Line:</b>'.__LINE__.'<b> | Debug: </b> Para() <br>';
		$this->pager_uri = $pager_uri;
		$this->SetPagerInterval();
	}


	function SetPagerInterval($interval=20, $left_interval=0, $right_interval=0) {
		/*COMMENT_FUNCTION*/ //print '<b> | Class:</b>'.__CLASS__.'<b> | function:</b>'.__FUNCTION__.'<b> | Line:</b>'.__LINE__.'<b> | Debug: </b> Para() <br>';
		
		if ($interval>0) {
			$half_interval = ($interval/2);
			$this->left_interval = $this->right_interval = round($half_interval,0);
		}
		else {
			$this->left_interval = $left_interval;
			$this->right_interval = $right_interval;
		}
	}


	function GetPager($url, $items_total, $items_per_page, $current_page=1, $type='PAGES', $css = ARRAY ()) {
		/*COMMENT_FUNCTION*/ //print '<b> | Class:</b>'.__CLASS__.'<b> | function:</b>'.__FUNCTION__.'<b> | Line:</b>'.__LINE__.'<b> | Debug: </b> Para($url='.$url.', $items_total='.$items_total.', $items_per_page='.$items_per_page.', $current_page='.$current_page.', '.var_dump($css).') <br>';
		
		global $lang;
		
		$type=strtoupper($type);
		$pager='';
		$step='';
		
		if ($current_page == 0) { $current_page = 1; }

		$pages_total = ($items_total / $items_per_page);
		$pages_total = round($pages_total,0);
		
		//print '<b> | Class:</b>'.__CLASS__.'<b> | function:</b>'.__FUNCTION__.'<b> | Line:</b>'.__LINE__.'<b> | Debug: $pages_total='.$pages_total.' <br>';
		if ($items_total > $pages_total * $items_per_page) { $pages_total++; } 
		//print '<b> | Class:</b>'.__CLASS__.'<b> | function:</b>'.__FUNCTION__.'<b> | Line:</b>'.__LINE__.'<b> | Debug: $pages_total='.$pages_total.' <br>';

		if ($current_page > $pages_total) { $current_page = $pages_total; }

		$prev_page = $current_page - 1;
		
		$next_page = $current_page + 1;
		if ($next_page == 1) {
			$next_page = 2;
		}
		

		if (isset ($css['div']) AND !empty ($css['div'])) {
			$pager .= '<div '.$css['div'].' >';
		}

		//$pager .= $lang['lang_link_pager_browse'].'&nbsp;&nbsp;';

		if ($current_page > 1) {
			if (isset ($css['a_prev']) AND !empty ($css['a_prev'])) {
				$css_a_prev = $css['a_prev'];
			}
			if ($current_page > 2) {
				$pager .= '<a '.$css_a_prev.' href="'.$url.$GLOBALS['abdj_url_amp'].$this->pager_uri.'=1" title="1-'.$items_per_page.'">|&#171;</a>';
			}
			if ($type == 'PAGES') { $step=$prev_page; }
			if ($type == 'STEPS') {	$step=(($prev_page-1)*$items_per_page+1).'-'.$prev_page*$items_per_page; }
			$pager .= '<a '.$css_a_prev.' href="'.$url.$GLOBALS['abdj_url_amp'].$this->pager_uri.'='.$prev_page.'" title="'.$step.'">&#171;</a>';
		}
		
		
		$rest_left_interval=0;
		if ($current_page - $this->left_interval < 0) {
			$rest_left_interval = ($current_page - $this->left_interval) * -1;
		}
		
		$rest_right_interval=0;
		if ($this->right_interval - ($pages_total - $current_page) > 0) {
			$rest_right_interval = $this->right_interval - ($pages_total - $current_page);
		}

		for ($i = 1; $i <= $pages_total; $i ++) {
			
			// Show next or previous ten pages.
			// This way only a interval of pages is shown if number of pages is very large.
			

			
			if (($i >= $current_page-(10+$rest_right_interval)) AND ($i <= $current_page+$this->right_interval+$rest_left_interval)) {
			//if (($i >= $current_page-10) AND ($i <= $current_page+10)) {
				if (isset ($css['a_current']) AND !empty ($css['a_current']) AND $current_page > 0 AND $i == $current_page) {
					$css_a = $css['a_current'];
				} else {
					if (isset ($css['a']) AND !empty ($css['a'])) {
						$css_a = $css['a'];
					}
				}
				
				
				if ($type == 'PAGES') { $step=$i; }
				if ($type == 'STEPS') {
					$step=(($i-1)*$items_per_page+1);
					$step .= '-';
					if ($i*$items_per_page < $items_total) { $step .= $i*$items_per_page; }
					else { $step .= $items_total; }
				}
				$pager .= '<a '.$css_a.' href="'.$url.$GLOBALS['abdj_url_amp'].$this->pager_uri.'='.$i.'" title="'.$step.'">'.$step.'</a>';
			} // if (($i >= $current_page-10) AND ($i <= $current_page+10))
		} // for
		
		
		//$pager .= $lang['lang_link_pager'].' '.$current_page.' of '.$pages_total.'&nbsp;';
		
		if ($current_page < $pages_total AND $pages_total > 1)
		{
			if (isset ($css['a_next']) AND !empty ($css['a_next'])) {
				$css_a_next = $css['a_next'];
			}
			if ($type == 'PAGES') { $step=$next_page; }
			if ($type == 'STEPS') {
				$step=(($next_page-1)*$items_per_page+1);
				$step .= '-';
				if ($next_page*$items_per_page < $items_total) { $step .= $next_page*$items_per_page; }
				else { $step .= $items_total; }
			}
			$pager .= '<a '.$css_a_next.' href="'.$url.$GLOBALS['abdj_url_amp'].$this->pager_uri.'='.$next_page.'" title="'.$step.'">&#187;</a>';
			if ($current_page + 1 < $pages_total) {
				if ($type == 'PAGES') { $step=$pages_total; }
				if ($type == 'STEPS') {	$step=(($pages_total-1)*$items_per_page+1).'-'.$items_total; }
				$pager .= '<a '.$css_a_next.' href="'.$url.$GLOBALS['abdj_url_amp'].$this->pager_uri.'='.$pages_total.'" title="'.$step.'">&#187;|</a>';
			}
		}

		if (isset ($css['div']) AND !empty ($css['div'])) {
			$pager .= '</div>';
		}

		return $pager;

	} // function GetPager()

} // class Pager
?>