<?php
class Abdj_Editor {

	function Abdj_Editor() {
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": <br>";

		$this->Parameters();
	} // function Abdj_Editor()

	function SetLanguage($language_array) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";
		$this->lang = $language_array;
	} // function SetLanguage()

	function Parameters() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		// Root path to editor directory
		$this->para_path_editor = $GLOBALS['abdj_path_editor']; //$GLOBALS['abdj_path_editor_fromadmin'];
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->para_path_editor=".$this->para_path_editor." <br>";

		// Unix timestamp
		$this->timestamp = $GLOBALS['abdj_config']['timestamp'];

		// spacer used to separate fild_ID from filename
		$this->para_fileid_spacer = ":";

		// Display width for CMSimple-Editor
		$this->para_editor_width = 500;

		// Undo feature on (TRUE), off (FALSE)
		$this->para_feature_undo = TRUE;

		// Number of undo files stored (1 to unlimited)
		$this->para_undo_amount = 5;

		// Directory, where undo files are stored
		$this->para_undo_dir = $GLOBALS['abdj_dir_editor_undo'];
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->para_undo_dir=".$this->para_undo_dir." <br>";

		// Spacer used to separate bak_filename form file_timestamp
		$this->para_undo_spacer = "_";

		// File extension used for undo files.
		$this->para_undo_extension = ".bak";

		// Root path to undo saves directory.
		$this->para_undo_path_editor_undo = $this->para_path_editor.$this->para_undo_dir;
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->para_undo_path_editor_undo=".$this->para_undo_path_editor_undo." <br>";

	} // function Parameters()

	function Set_Files_Allowed_Array($editor_files) {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$this->files_allowed_array = ARRAY ();

		if (is_array($editor_files)) {
			$count = 0;
			foreach ($editor_files AS $files) {
				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$files['path']=".$files['path']." - \$files['filename']=".$files['filename']." <br>";
				$count ++;

				if (!isset ($files['path'])) {
					$files['path'] = '';
				}
				if (!isset ($files['filename'])) {
					$files['filename'] = '';
				}
				if (!isset ($files['readable'])) {
					$files['readable'] = '';
				}
				if (!isset ($files['writeable'])) {
					$files['writeable'] = '';
				}
				if (!isset ($files['deleteable'])) {
					$files['deleteable'] = '';
				}

				$file_array[$count] = ARRAY ('id' => $count, 'path' => $files['path'], 'filename' => $files['filename'], 'readable' => $files['readable'], 'writeable' => $files['writeable'], 'deleteable' => $files['deleteable']);
				$this->files_allowed_array[$count] = $file_array[$count];
			}
		} else {
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": no \$editor_files! <br>";
		}

	} // function Set_Files_Allowed_Array()

	function Get_Selectbox_Files_Allowed() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$selectbox = '<input type="hidden" name="abdj_editor_submit_select" value="1"><select class="abdjedfiles" name="abdj_editor_file_id" size="1" onchange="this.form.submit()" >';

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() \$this->filename=".$this->filename." <br>";

		//if ((!empty ($this->file_id)) AND (file_exists($this->files_allowed_array["$this->file_id"]['path'].$this->files_allowed_array["$this->file_id"]['filename']))) {
		if ((!empty ($this->file_id)) AND (file_exists($this->filename))) {
			$selectbox .= '<option value="'.$this->file_id.$this->para_fileid_spacer.$this->filename.'" selected>'.$this->filename.'</option>';
			$selectbox .= '<option value="">&nbsp;&nbsp;&nbsp;&nbsp;----------------------------------------&nbsp;&nbsp;&nbsp;&nbsp;</option>';
		}

		foreach ($this->files_allowed_array AS $file_array) {
			if (!isset ($file_array['path'])) {
				$file_array['path'] = '';
			}
			if (!isset ($file_array['filename'])) {
				$file_array['filename'] = '';
			}

			$file = $file_array['path'].$file_array['filename'];
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para(\$file=$file) <br>";

			if (file_exists($file)) {
				$selectbox .= '<option value="'.$file_array['id'].$this->para_fileid_spacer.$file.'">'.$file.'</option>';
			}
		}

		$selectbox .= "</select>";

		return $selectbox;

	} // function Get_Selectbox_Files_Allowed()

	function Editor_Kernel() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$this->status_form = '';
		$this->file_permissions = '';
		$this->status_message = '';

		if (isset ($_POST['abdj_editor_action'])) {
			$this->action = $_POST['abdj_editor_action'];
		} else {
			$this->action = '';
		}

		if (isset ($_POST['abdj_editor_file_id'])) {
			$this->file_id = $_POST['abdj_editor_file_id'];
		} else {
			$this->file_id = '';
		}
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->file_id=$this->file_id<br>";

		if (isset ($_POST['abdj_editor_file_contents'])) {
			$this->file_contents = $_POST['abdj_editor_file_contents'];
		} else {
			$this->file_contents = '';
		}

		if (isset ($_POST['abdj_editor_undo_count'])) {
			$this->undo_count = $_POST['abdj_editor_undo_count'];
		} else {
			$this->undo_count = '';
		}

		if (isset ($_POST['abdj_editor_submit_select'])) {
			$this->form_editor_submit_select = $_POST['abdj_editor_submit_select'];
		} else {
			$this->form_editor_submit_select = '';
		}

		if (isset ($_POST['abdj_editor_submit_save'])) {
			$this->form_editor_submit_save = $_POST['abdj_editor_submit_save'];
		} else {
			$this->form_editor_submit_save = '';
		}

		if (isset ($_POST['abdj_editor_submit_undo'])) {
			$this->form_editor_submit_undo = $_POST['abdj_editor_submit_undo'];
		} else {
			$this->form_editor_submit_undo = '';
		}

		if (isset ($_POST['abdj_editor_submit_undo_delete'])) {
			$this->form_editor_submit_undo_delete = $_POST['abdj_editor_submit_undo_delete'];
		} else {
			$this->form_editor_submit_undo_delete = '';
		}

		if (isset ($_POST['abdj_editor_submit_cancel'])) {
			$this->form_editor_submit_cancel = $_POST['abdj_editor_submit_cancel'];
		} else {
			$this->form_editor_submit_cancel = '';
		}

		if (isset ($_POST['abdj_editor_submit_delete'])) {
			$this->form_editor_submit_delete = $_POST['abdj_editor_submit_delete'];
		} else {
			$this->form_editor_submit_delete = '';
		}

		if (isset ($_POST['abdj_editor_submit_deleted'])) {
			$this->form_editor_submit_deleted = $_POST['abdj_editor_submit_deleted'];
		} else {
			$this->form_editor_submit_deleted = '';
		}

		if (isset ($_POST['abdj_editor_submit_not_deleted'])) {
			$this->form_editor_submit_not_deleted = $_POST['abdj_editor_submit_not_deleted'];
		} else {
			$this->form_editor_submit_not_deleted = '';
		}

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->file_id='$this->file_id'<br>";

		if (empty ($this->action)) {
			$this->action = "edit_file";
		}

		$register_globals = ini_get('register_gobals');
		$magic_quotes = get_magic_quotes_gpc();
		if (($register_globals == TRUE) OR ($magic_quotes == TRUE)) {
			$this->file_contents = str_replace("\\\\", "~DOUBLEQUOTE~", $this->file_contents);
			$this->file_contents = stripslashes($this->file_contents);
			$this->file_contents = str_replace("~DOUBLEQUOTE~", "\\", $this->file_contents);
		} else {
		}

		// check if ID and filename correspond to each other
		// (because IDs of files may change dynamically)
		$this->filename = '';
		if (!empty ($this->file_id)) {
			list ($this->file_id, $this->filename) = split($this->para_fileid_spacer, $this->file_id);
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->file_id=".$this->file_id." - \$this->filename=".$this->filename."<br>";

			if (!isset($this->files_allowed_array["a"]['path'])) { $this->files_allowed_array["a"]['path']=''; }
			if (!isset($this->files_allowed_array["a"]['filename'])) { $this->files_allowed_array["a"]['filename']=''; }
			
			if ($this->files_allowed_array["$this->file_id"]['path'].$this->files_allowed_array["$this->file_id"]['filename'] != $this->filename) {
				foreach ($this->files_allowed_array AS $files_array) {
					//echo $files_array['path'].$files_array['filename']." == ".$this->filename."<br>";
					if ($files_array['path'].$files_array['filename'] == $this->filename) {
						//echo "ID changed from ".$this->file_id." to a;<br>filename old: ".$this->files_allowed_array["$this->file_id"]['path'].$this->files_allowed_array["$this->file_id"]['filename']."; ";
						$this->file_id = "a";
						$this->files_allowed_array["$this->file_id"] = $files_array;
						//echo "Filename new: ".$this->files_allowed_array["$this->file_id"]['path'].$this->files_allowed_array["$this->file_id"]['filename']."<br>";
						break;
					}
				}
				//$die_msg = $this->files_allowed_array["$this->file_id"]['path'].$this->files_allowed_array["$this->file_id"]['filename']." != ".$this->filename;
				//die($die_msg);
			}
		}

		//$this->file_contents = stripslashes($this->file_contents);

		if (!isset ($this->files_allowed_array["$this->file_id"]['readable'])) {
			$this->files_allowed_array["$this->file_id"]['readable'] = '';
		}

		if (($this->files_allowed_array["$this->file_id"]['readable'] == 0) OR (!empty ($this->form_editor_submit_cancel))) {
			$this->file_contents = "";
		}

		if (empty ($this->file_id)) {
			$this->status_form = "select";
			$this->status_message = $this->lang['status_select_file'];
		} // if (empty($this->file_id))
		else {
			$this->file = $this->files_allowed_array["$this->file_id"]['path'].$this->files_allowed_array["$this->file_id"]['filename'];
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->file=$this->file <br>";

			$file_exists = $GLOBALS['abdj_obj_common']->File_Exists($this->file, "FILE");

			if ($file_exists['success'] == FALSE) {
				$this->status_form = "select";
				$this->status_message_style = "error";
				$this->status_message = $file_exists['msg'];
			} // if ($file_exists['success'] == FALSE)
			else {

				if ($this->status_form != "select") {
					if ($this->files_allowed_array["$this->file_id"]['readable'] == 0) {
						$this->files_allowed_array["$this->file_id"]['writeable'] = 0;
						$this->files_allowed_array["$this->file_id"]['deleteable'] = 0;
						$this->status_form = "select";
						$this->status_message_style = "error";
						$this->status_message = $this->lang['status_perm_read_no'];
					} else
						if ($this->files_allowed_array["$this->file_id"]['writeable'] == 0) {
							$this->files_allowed_array["$this->file_id"]['deleteable'] = 0;
							$this->status_form = "readonly";
							$this->status_message_style = "error";
							$this->status_message = $this->lang['status_perm_read'];
						}

					if ($this->files_allowed_array["$this->file_id"]['readable'] == 1) {
						$this->file_permissions .= $this->lang['perm_read']."+ ";
					} else {
						$this->file_permissions .= "<font color=whitesmoke>".strtolower($this->lang['perm_read'])."- </font>";
					}
					if ($this->files_allowed_array["$this->file_id"]['writeable'] == 1) {
						$this->file_permissions .= $this->lang['perm_write']."+ ";
					} else {
						$this->file_permissions .= "<font color=whitesmoke>".strtolower($this->lang['perm_write'])."- </font>";
					}
					if ($this->files_allowed_array["$this->file_id"]['deleteable'] == 1) {
						$this->file_permissions .= $this->lang['perm_delete']."+ ";
					} else {
						$this->file_permissions .= "<font color=whitesmoke>".strtolower($this->lang['perm_delete'])."- </font>";
					}

					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->form_editor_submit_select=".$this->form_editor_submit_select." <br>";
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->file_id=".$this->file_id." <br>";
					if ((!empty ($this->form_editor_submit_select)) AND (!empty ($this->file_id)) AND ($this->files_allowed_array["$this->file_id"]['readable'] == 1)) {
						$this->file_contents = $GLOBALS['abdj_obj_common']->Read_File("STRING", FALSE, $this->file);
					}

					if ($this->para_feature_undo == TRUE) {
						if (!empty ($this->form_editor_submit_undo)) {
							if ($this->undo_count >= $this->para_undo_amount) {
								$this->undo_count = $this->para_undo_amount;
							} else {
								$this->undo_count++;
							}

							$read_undo = $this->ReadUndoFile();

							if ($read_undo['success'] == FALSE) {
								//$this->status_form           = "readonly";
								$this->status_message_style = "error";
								$this->status_message .= $read_undo['msg'];
							} else {
								$this->status_message_style = "ok";
								$this->status_message .= $read_undo['msg'];
								$this->file_contents = $read_undo['contents'];
							}
						}
					}

					$is_writeable = $GLOBALS['abdj_obj_common']->Is_Writeable($this->file, 'FILE');

					if ($is_writeable['success'] == FALSE) {
						$this->status_form = "readonly";
						$this->status_message_style = "error";
						$this->status_message .= $is_writeable['msg'];
					} else {
					}

				} else {
					$this->status_form = "select";
					$this->status_message = $file_exists['msg'];
				}
			} // if ($file_exists['success'] == TRUE)

		} // else if (empty($this->file_id))

		if (($this->action == "edit_file") OR (!empty ($this->form_editor_submit_select)) OR (!empty ($this->form_editor_submit_save)) OR (!empty ($this->form_editor_submit_cancel)) OR (!empty ($this->form_editor_submit_delete)) OR (!empty ($this->form_editor_submit_deleted)) OR (!empty ($this->form_editor_submit_undo_delete))) {

			if (!empty ($this->form_editor_submit_save)) {
				if ($this->para_feature_undo == TRUE) {
					$copy_undo = $this->CopyUndoFile();
				}

				$write = $GLOBALS['abdj_obj_common']->Write_File($this->file, TRUE, "begin", "STRING", $this->file_contents);

				//$this->status_form    = "select";
				$this->status_message .= $write['msg'].$copy_undo['msg'];
				if ($write['success'] == TRUE) {
					$this->status_message_style = "ok";
					if ($this->para_feature_undo == TRUE) {
						$this->undo_count = 0;
					}
				} else {
					$this->status_message_style = "error";
				}
			}

			if (!empty ($this->form_editor_submit_cancel)) {
				$this->status_form = "select";
				$this->status_message_style = "error";
				$this->status_message = $this->lang['status_canceled']." ".$this->lang['status_select_file'];
			}

			if (!empty ($this->form_editor_submit_delete)) {
				$this->status_form = "delete";
				$this->status_message_style = "error";
				$this->status_message = $this->lang['status_delete_really']." ".$this->file;
			}

			if (!empty ($this->form_editor_submit_deleted)) {
				$delete = $this->Delete_File();

				if ($delete['success'] == TRUE) {
					$this->file_contents='';
					$this->status_message_style = "ok";
					$this->status_form = "select";
				} else {
					$this->status_message_style = "error";
				}
				$this->status_message = $delete['msg'];
			}

			if (!empty ($this->form_editor_submit_not_deleted)) {
				$this->status_form = "edit";
				$this->status_message_style = "error";
				$this->status_message = $this->lang['status_canceled'];
			}

			if (!empty ($this->form_editor_submit_undo_delete)) {
				$delete_undo = $this->DeleteUndoFile();

				if ($delete_undo['success'] == TRUE) {
					$this->status_message_style = "ok";
					$this->status_form = "edit";
				} else {
					$this->status_message_style = "error";
				}
				$this->status_message = $delete_undo['msg'];
			}

			$editor = $this->Editor();
		}

		return $editor;

	} // function Editor_Kernel()

	function Editor() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$editor = $this->Edit_Form();

		$editor = $editor;

		return $editor;

	} // function Editor()

	function Edit_Form() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$form_textarea_readonly = '';

		if ($this->status_form != "delete") {
			$form_selectbox_files_allowed = $this->Get_Selectbox_Files_Allowed();
		}

		if (($this->status_form == "select") OR ($this->status_form == "readonly") OR ($this->status_form == "delete")) {
			$form_textarea_readonly = "readonly";
		}

		$edit_form = '<div class="abdjeditor"><p class="abdjedcap">'.$this->lang['editor_name'].'</p>';

		if ($this->status_form != "delete") {

			$edit_form .= '<form class="abdjedselect" name="editorselect" action="" method="post"><input type="hidden" name="abdj_editor_action" value="edit_file"><input type="hidden" name="abdj_editor_file_id" value="'.$this->file_id.$this->para_fileid_spacer.$this->filename.'"><p class="abdjedselect">'.$form_selectbox_files_allowed.' <input class="abdjedfiles" type="submit" name="abdj_editor_submit_select" value="'.$this->lang['form_button_select'].'"></p></form>';
		}

		$edit_form .= '<form name="editor" action="" method="post"><input type="hidden" name="abdj_editor_action" value="edit_file"><input type="hidden" name="abdj_editor_file_id" value="'.$this->file_id.$this->para_fileid_spacer.$this->filename.'">';

		if (($this->status_form != "select") AND ($this->status_form != "delete")) {
			//  (id:".$this->file_id.")
			$edit_form .= '<p class="abdjedperm"><b>'.$this->lang['form_field_file'].':</b> "'.$this->file.'"<br><i>'.$this->lang['form_field_permissions'].': '.$this->file_permissions.'</i></p>';
		}

		if ($this->status_form == "readonly") {
			$style_textarea = 'class="abdjedtextreadonly"';
		} else
			if ($this->status_form == "delete") {
				$style_textarea = 'class="abdjedtexterror"';
			} else {
				$style_textarea = 'class="abdjedtext"';
			}

		$edit_form .= '<p class="abdjedtext"><textarea '.$style_textarea.' name="abdj_editor_file_contents" rows="0" cols="0" '.$form_textarea_readonly.'>'.$this->file_contents.'</textarea><br></p>';

		$form_style_status = 'class="abdjedstatus"';

		if (!isset ($this->status_message_style)) {
			$this->status_message_style = '';
		}
		if ($this->status_message_style == "error") {
			$form_style_status = 'class="abdjedstatuserror"';
			;
		}
		if ($this->status_message_style == "ok") {
			$form_style_status = 'class="abdjedstatusok"';
		}

		$edit_form .= "<p ".$form_style_status." ><b>".$this->lang['form_field_status'].":</b> ";
		if (isset ($this->status_message)) {
			$edit_form .= $this->status_message;
		}
		$edit_form .= '</p><p class="abdjedfunc">';

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->para_feature_undo=".$this->para_feature_undo." <br>";
		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->status_form=".$this->status_form." <br>";

		// button UNDO DELETE
		if (($this->para_feature_undo == TRUE) AND ($this->status_form != "select") AND ($this->status_form != "delete")) {
			$edit_form .= ' <input class="abdjedfunc" type="submit" name="abdj_editor_submit_undo_delete" value="'.$this->lang['form_button_undo_delete'].'"> ';
			$edit_form .= ' <input type="hidden" name="abdj_editor_undo_count" value="'.$this->undo_count.'"> ';
		}

		// button UNDO
		if (($this->para_feature_undo == TRUE) AND ($this->status_form != "select") AND ($this->status_form != "delete")) {
			$edit_form .= ' <input class="abdjedfunc" type="submit" name="abdj_editor_submit_undo" value="'.$this->lang['form_button_undo'].'"> ';
			//$edit_form .= ' <input type="hidden" name=abdj_editor_undo_count value="'.$this->undo_count.'"> ';
		}

		if (!isset ($this->files_allowed_array["$this->file_id"]['deleteable'])) {
			$this->files_allowed_array["$this->file_id"]['deleteable'] = '';
		}
		if (($this->files_allowed_array["$this->file_id"]['deleteable'] == 1) AND ($this->status_form != "select")) {
			// button DELETE REALLY
			if ($this->status_form == "delete") {
				$edit_form .= ' <input class="abdjedfunc" type="submit" name="abdj_editor_submit_deleted" value="'.$this->lang['form_button_delete_really'].'"> ';
				$edit_form .= ' <input class="abdjedfunc" type="submit" name="abdj_editor_submit_not_deleted" value="'.$this->lang['form_button_not_deleted'].'"> ';
			}
			// button DELETE
			if (($this->status_form != "readonly") AND ($this->status_form != "delete")) {
				$edit_form .= ' <input class="abdjedfunc" type="submit" name="abdj_editor_submit_delete" value="'.$this->lang['form_button_delete'].'"> ';
			}
		}

		// button CANCEL
		if (!isset ($this->files_allowed_array["$this->file_id"]['writeable'])) {
			$this->files_allowed_array["$this->file_id"]['writeable'] = '';
		}
		if ((($this->files_allowed_array["$this->file_id"]['writeable'] == 1) OR ($this->files_allowed_array["$this->file_id"]['deleteable'] == 1)) AND ($this->status_form != "select") AND ($this->status_form != "readonly")) {
			$edit_form .= ' <input class="abdjedfunc" type="submit" name=abdj_editor_submit_cancel value="'.$this->lang['form_button_cancel'].'"> ';
			// button SAVE

			if (($this->status_form != "delete") AND ($this->status_form != "readonly")) {
				$edit_form .= ' <input class="abdjedfunc" type="submit" name=abdj_editor_submit_save value="'.$this->lang['form_button_save'].'"> ';
			}

		} // if ($this->status_form == "select")

		$edit_form .= "</p></form></div>";

		return $edit_form;

	} // function Edit_Form()

	function Write_File() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->file=$this->file <br>";

		$file_exists = $GLOBALS['abdj_obj_common']->File_Exists($this->file, "FILE");

		if ($file_exists['success'] == FALSE) {
			$write['success'] = FALSE;
			$write['msg'] = $file_exists['msg'];
		} else {
			$is_writeable = $GLOBALS['abdj_obj_common']->Is_Writeable($this->file, 'FILE');

			if ($is_writeable['success'] == FALSE) {
				$write['success'] = FALSE;
				$write['msg'] = $is_writeable['msg'];
			} else {
				$write = $GLOBALS['abdj_obj_common']->Write_File($this->file, TRUE, "BEGIN", "STRING", $this->file_contents);
				if ($write['success'] = TRUE) {
					$write['msg'] = $this->lang['status_file_saved'].": ".$this->file;
				}
			} // else if ($is_writeable['success'] == FALSE)
		} // else if ($file_exists['success'] == FALSE)

		return $write;

	} // function Write_File()

	function Delete_File() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		if ($this->files_allowed_array["$this->file_id"]['deleteable'] == 0) {
			$delete['success'] = FALSE;
			$delete['msg'] = $this->lang['perm_deleteable_no'].": ".$this->file;
		} else {
			$delete = $GLOBALS['abdj_obj_common']->Delete_File($this->file, 'FILE');
		}

		return $delete;

	} // function Delete_File()

	function ReadUndoFile() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$read_undo['success'] = FALSE;
		$read_undo['contents'] = "";
		$read_undo['msg'] = "";
		$undo_timestamps_array = ARRAY ();

		$dir_array = $GLOBALS['abdj_obj_common']->CollectDir($this->para_undo_path_editor_undo, "", $pos = 2);
		$files_array = $GLOBALS['abdj_obj_common']->CollectDirRemoveForbidden($dir_array['this_files'], "");

		if (empty ($files_array[0])) {
			$read_undo['success'] = FALSE;
		} // if (empty($files_array[0]))
		else {
			// get undo_timestamps from current file
			foreach ($files_array AS $files) {
				$files = substr($files, strrpos($files, "/") + 1);
				$files = str_replace($this->para_undo_extension, "", $files);
				list ($filename_undo, $timestamp_undo) = split($this->para_undo_spacer, $files);

				$filename_md5 = md5($this->file);

				if ($filename_md5 == $filename_undo) {
					array_push($undo_timestamps_array, $timestamp_undo);
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": $this->file, $filename_md5 <br>";
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": $filename_undo, $timestamp_undo <br>";
				}
			}

			rsort($undo_timestamps_array);

			// delete undo_files that are over the undo_amount
			$count = 0;
			foreach ($undo_timestamps_array AS $timestamp_undo) {
				$file_undo = $this->para_undo_path_editor_undo.md5($this->file).$this->para_undo_spacer.$timestamp_undo.$this->para_undo_extension;

				//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": $count/$this->undo_count: $file_undo <br>";

				$count ++;

				if ($count > $this->para_undo_amount) {
					unlink($file_undo);
				} // if ($count > $this->para_undo_amount)
				else {
					//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": $count == $this->undo_count, $file_undo <br>";
					if ($count == $this->undo_count) {
						$read_undo['contents'] = $GLOBALS['abdj_obj_common']->Read_File("STRING", FALSE, $file_undo);
						$read_undo['success'] = TRUE;
					}
				} // else if ($count > $this->para_undo_amount)

			} // foreach

		} // else if (empty($files_array[0]))

		if ($read_undo['success'] == TRUE) {
			$read_undo['msg'] = $this->lang['undo_restored']." [".$this->undo_count."]";
		} else {
			$read_undo['msg'] = $this->lang['undo_restored_no']." [".$this->undo_count."]";
		}

		return $read_undo;

	} // function ReadUndoFile()

	function CopyUndoFile() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$copy_undo['success'] = FALSE;
		$copy_undo['msg'] = "";

		//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->para_undo_path_editor_undo=".$this->para_undo_path_editor_undo." <br>";

		if ($this->para_feature_undo == TRUE) {
			$file_bak = $this->para_undo_path_editor_undo.md5($this->file).$this->para_undo_spacer.$this->timestamp.$this->para_undo_extension;

			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$this->file=".$this->file." <br>";
			//print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": \$file_bak=$file_bak <br>";

			if (!@ copy($this->file, $file_bak)) {
				//echo $this->file." could not be backed up as ".$file_bak."<br>";
				$copy_undo['success'] = FALSE;
				$copy_undo['msg'] = "<br>".$this->lang['undo_saved_no'].": ".$this->file;
			} else {
				$copy_undo['success'] = TRUE;
				$copy_undo['msg'] = "<br>".$this->lang['undo_saved'].": ".$this->file;
			}
		}
		return $copy_undo;

	} // function CopyUndoFile()

	function DeleteUndoFile() {
		//COMMENT_FUNCTION// //print "File ".__FILE__." Class ".__CLASS__." Function ".__FUNCTION__." Line ".__LINE__.": Para() <br>";

		$delete_undo['success'] = FALSE;
		$delete_undo['msg'] = "";

		$dir_array = $GLOBALS['abdj_obj_common']->CollectDir($this->para_undo_path_editor_undo, "", $pos = 2);
		$files_array = $GLOBALS['abdj_obj_common']->CollectDirRemoveForbidden($dir_array['this_files'], "");

		if (empty ($files_array[0])) {
			$delete_undo['success'] = FALSE;
			$delete_undo['msg'] = $this->lang['status_undo_deleted_no_files'];
		} // if (empty($files_array[0]))
		else {
			foreach ($files_array AS $file) {
				$delete_undo = $GLOBALS['abdj_obj_common']->Delete_File($file, 'FILE');
			}

		} // else if (empty($files_array[0]))

		return $delete_undo;

	} // function DeleteUndoFile()

} // class Abdj_Editor()
?>